--[[
local function rgb(r, g, b)
	return r/255, g/255, b/255
end
]]

local _gname = 'DontBuyIt'
local _gtt   = CreateFrame('GameTooltip', _gname, UIParent, 'GameTooltipTemplate')
local _gold  = { 1.0, 0.8, 0.0 }
local _gray  = { 0.5, 0.5, 0.5 }

local function update_merchant_patterns()
	if not _G.MerchantFrame or not _G.MerchantFrame:IsShown() then return end

	local name, texture, price, stackCount, numAvailable, isUsable, extendedCost

	local function check_known(b)
		-- Vérifie toutes les lignes du tooltip, en commençant par la fin
		-- ("Déjà connu" est normalement en dernier ou avant-dernier)
		_gtt:SetOwner(b, 'ANCHOR_RIGHT')
		_gtt:SetMerchantItem(b:GetID())
		for x = _gtt:NumLines(), 1, -1 do
			if string.find(_G[_gname .. 'TextLeft' .. x]:GetText(), ITEM_SPELL_KNOWN) then
				return true
			end
		end
		return false
	end

	for i = 1, 10 do	-- 10 items/page dans la fenêtre
		local bg = _G['MerchantItem' .. i]
		local b  = _G['MerchantItem' .. i .. 'ItemButton']

		if b:IsShown() then
			_, _, price, stackCount, numAvailable, isUsable, extendedCost = GetMerchantItemInfo(b:GetID())

			if isUsable and (numAvailable ~= 0) then
				if check_known(b) then
					-- Recettes déjà connues en jaune
					    SetItemButtonNameFrameVertexColor(bg, unpack(_gold))
					         SetItemButtonSlotVertexColor(bg, unpack(_gold))
					      SetItemButtonTextureVertexColor(b,  unpack(_gold))
					SetItemButtonNormalTextureVertexColor(b,  unpack(_gold))
				elseif (price / stackCount) > GetMoney() then
					    SetItemButtonNameFrameVertexColor(bg, unpack(_gray))
					         SetItemButtonSlotVertexColor(bg, unpack(_gray))
					      SetItemButtonTextureVertexColor(b,  unpack(_gray))
					SetItemButtonNormalTextureVertexColor(b,  unpack(_gray))
				end
			end
		end
	end

	-- S'assure que notre tooltip est caché
	_gtt:Hide()
end

hooksecurefunc('MerchantFrame_UpdateMerchantInfo', update_merchant_patterns)
